
set scheme plotplain
import delimited "XXX.csv", encoding(ISO-8859-1) clear // user should replace with name of the .csv created by the "kss_chk" function.
rename v1 y
rename v2 id
rename v3 firmid_orig
rename v4 firmid
rename v5 group
rename v6 fe
rename v7 kss_variance
rename v8 kss_variance_group0

bys firmid: egen fe_00 = mean(fe) if group == 0
bys firmid: egen fe_0 = mean(fe_00) 
drop fe_00

bys firmid: egen fe_00 = mean(fe) if group == 1
bys firmid: egen fe_1 = mean(fe_00) 
drop fe_00

drop fe

xtile quantiles = fe_1, nquantile(100)


*Normalize
qui sum fe_0
replace fe_0= fe_0-r(mean)

qui sum fe_1
replace fe_1= fe_1-r(mean)


*Regression
reg fe_0 fe_1 
gen fe_pred =_b[_cons]+_b[fe_1]*fe_1




local biased_AKM = round(_b[fe_1],0.001)
sum fe_1
local biased_var = r(sd)^2
sum kss_variance
local kss_var    = r(mean)

sum fe_0
local mean_fe_0=r(mean)

sum fe_1
local mean_fe_1=r(mean)

local unbiased_KSS = round(`biased_AKM'*(`biased_var'/`kss_var'),0.001)
gen fe_0_fake =(`mean_fe_0-'-`unbiased_KSS'*`mean_fe_1') + `unbiased_KSS'*fe_1

*Correlation
corr fe_0 fe_1
local crr = round(r(rho),0.01)

sum kss_variance_group0
local kss_var0=r(mean)
corr fe_0 fe_1, cov
local crr_adjusted = (r(cov_12)/(sqrt(`kss_var')*sqrt(`kss_var0')))
local crr_adjusted=round(`crr_adjusted',0.01)



collapse fe_0 fe_1 fe_0_fake fe_pred, by(quantiles)

reg fe_0 fe_1


twoway (scatter fe_0 fe_1, yaxis(1) msymbol(square) mcolor(cranberry) legend(label(1 "Firm effects - Young vs. Old"))) (lfit fe_pred fe_1, yaxis(1) lcolor(cranberry) lpattern(solid) legend(label(2 "Regression Line"))) (lfit fe_1 fe_1, yaxis(1) lcolor(dknavy) lwidth(vthin) lpattern(dash)  legend(label(3 "Regression Line"))), xlabel(-0.8(0.2)0.8) ylabel(-0.8(0.2)0.8)  legend(off) ytitle("Firm Effects - Younger Workers") xtitle("Firm Effects - Older Workers") note("PI Slope: `biased_AKM'; PI Correlation: `crr'." "KSS Slope: `unbiased_KSS'; KSS Correlation: `crr_adjusted'." "Test Statistic for equal firm effects: 3.95.",  pos(11) place(w)) plotregion(margin(zero))
graph export "figures/figure1",replace
graph save  "figures/figure1",replace
