use  data_computation.dta, clear ///this file contains the information about computation as collected in the associated matlab file



replace TIME_JLL=TIME_JLL/60
replace TIME_EXACT=TIME_EXACT/60
gen 	diff = (JLL + B_l + 0.5*B_u_minus_B_l)
sum K


*twoway 	(connect TIME_JLL K if p==500, msymbol(square) mcolor(gold) lcolor(gold) yaxis(1) legend(label(1 "Computation Time - JLA "))) (connect TIME_EXACT K if p==500, msymbol(square) mcolor(ltblue) lcolor(ltblue) yaxis(1) legend(label(2 "Computation Time - Exact"))) (connect diff K if p==500, msymbol(circle) mcolor(pink) lcolor(pink) yaxis(2) legend(label(3 "Absolute Difference b/w JLA Approximation and Exact Estimate of Variance of Firm Effects"))), yline(0, axis(2) lpattern(dot) lcolor(olive_teal))  ytitle("Minutes (Logarithmic Scale)") ytitle("Difference b/w Exact and JLA", axis(2)) xtitle("Total Number of Person + Firm Effects") ylabel(0(0.0001)0.001, axis(2)) ylabel(0 5 200 400 600 1000) legend(ring(2) position(6) rows(3)) xlabel(700000 "700,000" 900000 "900,000" 1000000 "1,000,000" 1100000 "1,100,000") yscale(log)
*graph export "computation_time_p500.pdf",replace


*twoway 	(connect TIME_JLL K if p==2500, msymbol(square) mcolor(gold) lcolor(gold) yaxis(1) legend(label(1 "Computation Time - JLA"))) (connect TIME_EXACT K if p==2500, msymbol(square) mcolor(ltblue) lcolor(ltblue) yaxis(1) legend(label(2 "Computation Time - Exact"))) (connect diff K if p==2500, msymbol(circle) mcolor(pink) lcolor(pink) yaxis(2) legend(label(3 "Absolute Difference b/w JLA Approximation and Exact Estimate of Variance of Firm Effects"))), yline(0, axis(2) lpattern(dot) lcolor(olive_teal))  ytitle("Minutes (Logarithmic Scale)") ytitle("Difference b/w Exact and JLA", axis(2)) xtitle("Total Number of Person + Firm Effects") ylabel(0(0.0001)0.001, axis(2)) ylabel(0 15 200 400 600 1000) xlabel(700000 "700,000" 900000 "900,000" 1000000 "1,000,000" 1100000 "1,100,000") legend(ring(2) position(6) rows(3)) yscale(log) 
*graph export "computation_time_p2500.pdf",replace

 

twoway 	(connect TIME_EXACT K if p==2500, msymbol(square) mcolor(pink) lcolor(pink) yaxis(1) legend(label(1 "Computation Time - Exact"))) (connect TIME_JLL K if p==2500, msymbol(square) mcolor(gold) lcolor(gold) yaxis(1) legend(label(2 "Computation Time - JLA with p=2500")))  (connect TIME_JLL K if p==500, msymbol(square) mcolor(ltblue) lcolor(ltblue) lpattern(solid) yaxis(1) legend(label(3 "Computation Time - JLA with p=500"))), ytitle("Minutes (Logarithmic Scale)")  xtitle("Number of Person and Firm Effects") ylabel(1 3 5 100 200 500) xlabel(700000 "700,000" 900000 "900,000" 1000000 "1,000,000" 1100000 "1,100,000") legend(ring(0) position(11) rows(4) bmargin(small) ) yscale(log) legend(order(1 2 3))
graph export "computation_time_T.pdf",replace

twoway 	(connect diff K if p==500, msymbol(circle) mcolor(ltblue) lcolor(ltblue) lpattern(shortdash) msize(small) yaxis(1) legend(label(1 "Estimate - JLA with p=500"))) (connect diff K if p==2500, msymbol(circle) mcolor(gold) lcolor(gold) yaxis(1) lpattern(shortdash) msize(small) legend(label(2 "Estimate - JLA with p=2500"))) (connect exact K if p==500, msymbol(circle) mcolor(pink) lcolor(pink) lpattern(shortdash) msize(small) yaxis(1) legend(label(3 "Estimate - Exact Computation"))) (connect PI K if p==500, msymbol(circle) mcolor(green) lcolor(green) lpattern(shortdash) msize(small) yaxis(1) legend(label(4 "Estimate - Plug-in"))),  ytitle("Variance of Firm Effects", axis(1)) xtitle("Number of Person and Firm Effects") ylabel(0.020(0.005)0.04, axis(1))  xlabel(700000 "700,000" 900000 "900,000" 1000000 "1,000,000" 1100000 "1,100,000") legend(ring(0) position(11) rows(4) bmargin(small)) legend(order(1 2 3 4 ))
graph export "quality_T.pdf",replace


 
