use  data_computation_CHK.dta, clear ///this file contains the information about computation as collected in the associated matlab file


replace TIME_JLL=TIME_JLL/60
gen diff = JLL + B_l + 0.5*B_u_minus_B_l
sum True_Theta
local THETA = r(mean)



*twoway 	(connect TIME_JLL K if p==250, msymbol(square) mcolor(gold) lcolor(gold) yaxis(1) legend(label(1 "Computation Time (First Y-Axis)"))) (connect diff K if p==250, msymbol(square) mcolor(ltblue) lcolor(ltblue) yaxis(2) legend(label(2 "JLA Approximation of Variance of Firm Effects "))) (connect PI K if p==250, msymbol(circle) mcolor(dknavy) lcolor(dknavy) yaxis(2) legend(label(3 "PI Variance of Firm Effects "))) (connect True_Theta K if p==250, msymbol(circle) mcolor(pink) lcolor(pink) yaxis(2) legend(label(4 "True Variance of Firm Effects "))), ytitle("Minutes") ytitle("Variance of Firm Effects", axis(2)) xtitle("Total Number of Person + Firm Effects") ylabel(0.02(0.01)0.035, axis(2)) ylabel(0(60)120, axis(1)) xlabel(1000000 "1,000,000" 3000000 "3,000,000" 6000000 "6,000,000" 10000000 "10,000,000" 14000000 "14,000,000")  legend(ring(0) position(1) rows(3) bmargin(large) size(vsmall)) 
*graph export "computation_time_CHK_250.pdf",replace

*twoway 	(connect TIME_JLL K if p==500, msymbol(square) mcolor(gold) lcolor(gold) yaxis(1) legend(label(1 "Computation Time (First Y-Axis)"))) (connect diff K if p==500, msymbol(square) mcolor(ltblue) lcolor(ltblue) yaxis(2) legend(label(2 "JLA Approximation of Variance of Firm Effects "))) (connect PI K if p==500, msymbol(circle) mcolor(dknavy) lcolor(dknavy) yaxis(2) legend(label(3 "PI Variance of Firm Effects "))) (connect True_Theta K if p==500, msymbol(circle) mcolor(pink) lcolor(pink) yaxis(2) legend(label(4 "True Variance of Firm Effects "))), ytitle("Minutes") ytitle("Variance of Firm Effects", axis(2)) xtitle("Total Number of Person + Firm Effects") ylabel(0.02(0.01)0.035, axis(2)) ylabel(0(60)120, axis(1)) xlabel(1000000 "1,000,000" 3000000 "3,000,000" 6000000 "6,000,000" 10000000 "10,000,000" 14000000 "14,000,000")  legend(ring(0) position(1) rows(3) bmargin(large) size(vsmall)) 
*graph export "computation_time_CHK_500.pdf",replace

twoway 	(connect TIME_JLL K if p==250, msymbol(square) mcolor(ltblue) lcolor(ltblue) lpattern(solid) legend(label(1 "Computation Time - JLA with p=250"))) (connect TIME_JLL K if p==500, msymbol(square) mcolor(gold) lcolor(gold) legend(label(2 "Computation Time - JLA with p=500"))), ytitle("Minutes") ylabel(0(30)90) xtitle("Number of Person and Firm Effects (in millions)") xlabel(1000000 "1M" 3000000 "3M" 6000000 "6M" 10000000 "10M" 14000000 "14M")  legend(ring(0) position(11) rows(2) bmargin(small) ) 
graph export "computation_time.pdf",replace
twoway 	(connect diff K if p==250, msymbol(circle) mcolor(ltblue) lcolor(ltblue) lpattern(shortdash) msize(small) legend(label(1 "Estimate - JLA with p=250"))) (connect diff K if p==500, msymbol(circle) mcolor(gold) lcolor(gold) yaxis(1) lpattern(shortdash) msize(small) legend(label(2 "Estimate - JLA with p=500"))) (connect PI K if p==250, msymbol(circle) mcolor(green) lcolor(green) lpattern(shortdash) msize(small) yaxis(1) legend(label(3 "Estimate - Plug-in"))) (connect True_Theta K if p==250, msymbol(circle) mcolor(pink) lcolor(pink) lpattern(shortdash) msize(small) yaxis(1) legend(label(4 "True value"))), ytitle("Variance of Firm Effects") xtitle("Number of Person and Firm Effects (in millions)") ylabel(0.02(0.01)0.04) xlabel(1000000 "1M" 3000000 "3M" 6000000 "6M" 10000000 "10M" 14000000 "14M")  legend(ring(0) position(11) rows(4) bmargin(small)) legend(order(1 2 3 4 ))
graph export "approximation.pdf",replace
