********************************************************************************

*READ JOB OPTIONS FROM HPC* 	
					
********************************************************************************
local prov_index		= `1'
local array_id 			= `2'
********************************************************************************

*PATHS* 	
					
********************************************************************************
scalar drop _all
matrix drop _all
scalar drop _all
capture log close
set more off
global dir_main "/accounts/projects/pkline/decomposition/Replication/build"
global dir_tmp "/scratch/public/leave_out/replication"
cd $dir_main
********************************************************************************

*KEY GLOBALS* 	
					
********************************************************************************
global controls_to_use age type_worker
global dep_variable y*
********************************************************************************

*READ CUT* 	
					
********************************************************************************
if `prov_index'== 1 {
global cityName_log="All_Veneto" // Column 1 of KSS
}

if `prov_index'== 2 {
global cityName_log="young_All_Veneto" // Column 2 of KSS
}

if `prov_index'== 3 {
global cityName_log="old_All_Veneto" // Column 3 of KSS
}

if `prov_index'== 4 {
global cityName_log="All_Veneto" // Appendix Table A.1 in KSS
}

global provGLOBAl=`prov_index'
********************************************************************************

*BUILD THE DATA* 	
					
********************************************************************************
*build from original VWH raw files a person-year .dta that will be then used for analysis
if `array_id' == 1{
	capture log close
	log using "logs/build_veneto_file.log", replace
	do "build"
	capture log close
}

*export files for analysis according with a specific cut as specified by the global $cityName_log 
if `array_id' == 2{
	capture log close
	log using "logs/estimation_file_`prov_index'.log", replace
	do "estim"
	capture log close
}